import { useState } from 'react';
import Taro from '@tarojs/taro';
import del from '@/assets/icons/landlord/delete.png'
import Popup from '@/components/Popup'
import { View, Text, Image, Textarea, Label, Button } from '@tarojs/components';
import { update, deleteExtend } from '@/services/landlord'
import SlideView from '@/components/SlideView';
import './style.less'

export default (props) => {
  const { item, setReset } = props
  const [eimg, seteImg] = useState(item.content)
  const handerChange = () => {
    Taro.chooseImage({
      count: 1,
      success: function (res) {
        seteImg(res.tempFilePaths[0])
        const date = {
          content: res.tempFilePaths[0],
          contentType: 'image'
        }
        update(item.extId, { ...item, ...date })
      }
    })
  }
  const [showCutover, setShowCutover] = useState(false)
  const showText = () => {
    setShowCutover(true)
  }
  const onClose = () => {
    setShowCutover(false)
    setReset(true)
  }
  const detele = [
    {
      src: del, // icon的路径
    }
  ]
  const [content, setContent] = useState(item.content)
  const handelDelete = () => {
    deleteExtend(item.extId)
    setReset(true)
  }
  const handelDelete2 = () => {
    deleteExtend(item.extId)
    setReset(true)
  }
  //判断是否只有空 空格 回车
  const javaTrim = (str) => {
    for (var i = 0; (str.charAt(i) == ' ') && i < str.length; i++);
    if (i == str.length) return ''; //whole string is space
    var newstr = str.substr(i);
    for (var i = newstr.length - 1; newstr.charAt(i) == ' ' && i >= 0; i--);
    newstr = newstr.substr(0, i + 1);
    return newstr;
  }
  const handelEdit = () => {
    var content = document.getElementById('content').value

    content = content.replace(/\n/g, '');
    if (javaTrim(content) == '') {
      Taro.showToast({
        title: '您还没有添加文字哦',
        icon: 'none'
      })
      return;
    }
    setContent(content)
    const date = {
      content,
      contentType: 'text'
    }
    update(item.extId, { ...item, ...date })
    onClose()
  }
  return (
    <View id='det'>
      <Popup show={showCutover} onClose={onClose}>
        <View className='editword'>
          <View style={{ marginBottom: '25px' }}>
            <View className='rzline' /><Label className='srl mg'>修改文字</Label><View className='rzline' />
          </View>
          <View>
            <Textarea className='storezn' value={content} id='content' />
          </View>
          <View>
            <Button className='cancel' onClick={onClose}>取消</Button>
            <Button className='btn' onClick={handelEdit}>确认修改</Button>
          </View>
        </View>
      </Popup>
      {
        item.contentType == 'image' ?
          <View>
            <SlideView del onDelete={handelDelete}>
              <Image src={eimg} mode='widthFix' style={{ width: '100%', display: 'block' }} onClick={handerChange} />
            </SlideView>
          </View>
          :
          item.contentType == 'text' ?
            <View>
              <SlideView del onDelete={handelDelete2}>
                <View className='storezn' onClick={showText}>{content}</View>
              </SlideView>
            </View>
            : null
      }
    </View>
  )
}